var ExtractTextPlugin = require('extract-text-webpack-plugin')

const vueLoaders = function() {
  var cssLoader = {
    loader: 'css-loader',
    options: {
      minimize: false,
      sourceMap: false,
    },
  }
  var postcssLoader = {
    loader: 'postcss-loader',
    options: {
      sourceMap: false,
    },
  }

  function generateLoaders(loader, loaderOptions) {
    var loaders = [cssLoader, postcssLoader]
    if (loader && loader !== 'css') {
      loaders.push({
        loader: loader + '-loader',
        options: {
          sourceMap: false,
          ...loaderOptions,
        },
      })
    }

    return ExtractTextPlugin.extract({
      use: loaders,
    })
  }

  return {
    css: generateLoaders(),
    scss: generateLoaders('sass', {
      includePaths: ['src/styles'],
      data: `@import "variables";`,
    }),
  }
}

// Generate loaders for standalone style files (outside of .vue)
const loaders = function() {
  var output = []
  var loaders = vueLoaders()
  for (var extension in loaders) {
    var loader = loaders[extension]
    output.push({
      test: new RegExp('\\.' + extension + '$'),
      use: loader,
    })
  }
  return output
}

module.exports = {
  loaders,
  vueLoaders,
}
