var exec = require('child_process').exec
const fs = require('fs')
const path = require('path')
const tmp = require('tmp')

function UploadPlugin() {}

const shell = command =>
  new Promise((resolve, reject) => {
    exec(command, error => {
      if (error) {
        console.error(`exec error: ${error}`)
        reject(error)
      } else {
        resolve()
      }
    })
  })

UploadPlugin.prototype.apply = function(compiler) {
  compiler.plugin('done', async function() {
    if (!fs.existsSync('dist/asset')) {
      return
    }
    const qshell = path.resolve(__dirname, 'qshell')
    tmp.dir(function _tempDirCreated(err, tmpPath) {
      if (err) throw err
      const conf = {
        src_dir: tmpPath,
        bucket: process.env.QINIU_BUCKET || 'zanquan',
        overwrite: true,
        skip_suffixes: '.DS_Store',
        rescan_local: true,
      }
      tmp.file((err, configFile) => {
        if (err) throw err
        fs.writeFile(configFile, JSON.stringify(conf), async () => {
          await shell(`mv dist/asset ${tmpPath}`)
          await shell(`${qshell} qupload ${configFile}`)
          await shell(`rm -rf ${configFile}`)
        })
      })
    })
  })
}

module.exports = UploadPlugin
